/*Programa que genera el grafo apartir de la matriz de Adyacencia */
/*Modo Grafico solo corre en Borland C++*/

#include "stdlib.h"
#include "graphics.h"
#include "dos.h"
#include "conio.h"
#include "stdio.h"
#include "math.h"
#include "complex.h"
#include "bios.h"
#include "iostream.h"
#include "string.h"
#include "ctype.h"
#define tecla_Esc 283
#define maxvert 10

typedef struct {
   int N;
   char V[maxvert];
   //Se lamacena el valor ponderado del grafo
   float Mponderada[maxvert][maxvert];
   //Se almacena 1 0 cero dependiendo del usuario
   int A[maxvert][maxvert];
   }Grafo;

union REGS reg;				// variable global para control del mouse
struct REGPACK res;			// variable global para lectura de datos

/*variables globales*/
char letra[]=" ";
int cont,Cvertices;
int Bcolor=0,pantalla=0;
char Vponderado;

/* Inicializa el mouse en la posicion indicada */
void inicia_mouse(int x,int y);
/* Muestra mouse en la pantalla */
void mostrar_mouse();
/* Oculta mouse en la pantalla */
void ocultar_mouse();
void estado_mouse(int *x,int *y, int *izq, int *der);
/*funcion para dar fondo*/
void fondo(int ,int );
/*Funcion que genera el nuemro de rectangulos*/
void crear_rectangulos(int ,int ,Grafo *G);
void presentar_dato(int, int, int,int &Mkey,Grafo *G,int , int);
void inigrafo(Grafo *G);
void Nuevo_vertice(Grafo *G,char X,int);
void boton_salida_siguiente(int ,int,int ,int &Mkey);
void dibujar_circulos(int frec,Grafo Gf);
void dibujar_lineas(Grafo Gt);
/*Crea la lista de Destino de la Matris*/
void dibujar_Mdir(int Nmax,Grafo Gt);
/*Funcion que determina el tipo de grafo ya sea dirigido o No dirigido*/
void funcion_determi_tipo_grafo(int ,int ,Grafo Gf);
/*Funcion para dibujar el directorio de nodos*/
void dibuja_directori_nodos(int ,int,int ,Grafo Gt);


void main(){
       clrscr;
	Grafo Gf,*G;
	char Vx;
	int Cantnodos;
	int *valor;
	int gdriver = DETECT, gmode, errorcode,key=0;// variables para modo grfico
	int numx=0,numy=0;// variable bandera para salir
	int x,y,izq,der; // datos de la posicion y botones del mouse
	char cadena[81],selecdirec[1],selecdirec2[1];// buffer para desplegar textos en pantalla
	inigrafo(&Gf);
      //G=&Gf;
	clrscr();
	 // setbkcolor(1);
	//Codigo que pide el tamao de la matris
	    do {
		cout<<"\n\nIntrodusca la dimension de la Matriz ";
		cout<<"\nFila: ";
		cin>>numx;
		cout<<"Columna: ";
		cin>>numy;
	       } while((numx>=11)||(numy>=11));//Blucle hasta que se a falso
		    /*Para pedir la mayor cantidad de nodos o vertices*/
		    if(numx>numy)
		    Cvertices=numx;
		    else
		    Cvertices=numy;

		cout<<"\nLlennado los Valores de Vertices";
		for(int i=0;i<Cvertices;i++) {
		cout<<"\nInserte el Vertice["<<i+1<<"]:";
		cin>>Vx;
		Nuevo_vertice(&Gf,Vx,i);
		}
		cout<<"\nLa Matris Introducida es: MATRIZ["<<numx<<"]"<<"["<<numy<<"]"<<endl;
		cout<<"Su grafo es ponderado s/n:";
		Vponderado=getch(); //Lo hice asi por que si pones cin>>tendras problema con la matris[10][10] por problema de compatibilidad de versiones C y C++
		Vponderado=toupper(Vponderado);
		cout<<Vponderado;
		cout<<"\n\nPresione Cualquier tecla Para continuar con el modo GRAFICO.........";
		getch();

		/***inicializa modo grafico********/
		initgraph(&gdriver, &gmode, ""); // inicializa modo grafico
		errorcode = graphresult();// lee el resultado de inicializacion
			// Ingresa si ocurri error
			    if (errorcode != grOk){
			       printf("ERROR en Graficos: %s\n", grapherrormsg(errorcode));
			       printf("Presione una tecla para salir...");
			       getch();// pausa
			       exit(1);// termina el programa con error
					      }

		/** Inicializa Pantalla 1 de introduccion de la matriz *****************/
	 if(pantalla==0) {
	     fondo(7,1);
	      //Llenado interno del rectangulo que se crea Boton salida
	     setcolor(getmaxcolor());
	     setfillstyle(SOLID_FILL,3);
	     rectangle(35,440,100,460);
	     rectangle(530,415,605,435); //Boton Siguiente>
	     floodfill(38,442,getmaxcolor());
	     floodfill(537,417,getmaxcolor());//Llenado de color interno  del boton
					      //Siguiente
	     setcolor(59);
	     outtextxy(140,40,"MATRIZ DE ADYACENCIA GENERADA");
	     outtextxy(540,420,"Siguie>");
	     outtextxy(45,446,"SALIR");
	     inicia_mouse(20,20);// inicia el mouse en la posicion 200,200
	     crear_rectangulos(numx,numy,&Gf);
	/* inicia ciclo infinito */
	while(key!=tecla_Esc){//inicia ciclo infinito para control del mouse

		*valor=0;
	     /*
		estado_mouse(&x,&y,&izq,&der); //retorna los valores actuales con punteros
		sprintf(cadena,"Posicion X:%3d, Y:%3d, Boton izquierdo: %1d, Boton derecho: %1d",x,y,izq,der);
		setcolor(1); //escoje el color en la variable color
		outtextxy(100,200,cadena);// se grafica status en pantalla con blanco
		delay(10); // Se espera 40 microsegundos para evitar parpadeo
			  // este tiempo de retardo decrementa el potencial del programa, pero es necesario hacerlo en este
			 // programa especifico Evite en lo posible incluir retardos dentro  del ciclo infinito.
		setcolor(7);// escoje el color negro
		outtextxy(100,200,cadena);// se borra el status con color negro
	       */

		estado_mouse(&x,&y,&izq,&der); //retorna los valores actuales con punteros
		/* Esta es la rutina basica para un boton */
		presentar_dato(x,y,izq,key,&Gf,numx,numy);
		/*Repinta los botones con los colores primeros*/
		setcolor(63);
		outtextxy(540,420,"Siguie>");
		/*repinta los botons con los colo5res Onmouseover*/
		boton_salida_siguiente(x,y,izq,key);


		}
	    }
   closegraph(); // cierra modo grafico
   /*Pantalla en modo Msdos para llenado del grafo ponderado*/
   if(pantalla==1) {
	   cout<<"\nINTRODUCIENDO LOS VALORES PONDERADOS DEL GRAFO"<<endl;
	     for(i=1;i<=numx;i++)
		for(int j=1;j<=numy;j++) {
		    if(Gf.A[i-1][j-1]==49){
		      cout<<endl<<"Introdusca el valor ponderado entre los Nodos [";
		      cout<<Gf.V[i-1]<<"]["<<Gf.V[j-1]<<"]:";
		      cin>>Gf.Mponderada[i-1][j-1];
					   }
		      }
		      cout<<"\nPresione cualquier tecla para continuar.....";
		      getch();
		}

	  if(pantalla==2||pantalla==1) {
		     /***inicializa modo grafico********/
		initgraph(&gdriver, &gmode, ""); // inicializa modo grafico
		fondo(57,2);
		errorcode = graphresult();// lee el resultado de inicializacion
			// Ingresa si ocurri error
			    if (errorcode != grOk){
			       printf("ERROR en Graficos: %s\n", grapherrormsg(errorcode));
			       printf("Presione una tecla para salir...");
			       getch();// pausa
			       exit(1);// termina el programa con error

			       }
			 /*Funcion dibuja Grafo*/
			  dibujar_circulos(Cvertices,Gf);
			  dibujar_lineas(Gf);
			  dibujar_Mdir(Cvertices,Gf);
			  funcion_determi_tipo_grafo(numx,numy,Gf);
			  setcolor(62);
			  outtextxy(350,440,"<Z>Para ver Directorio de Nodos");
			  outtextxy(350,455,"<Cualquier Tecla>Para Salir");
			  selecdirec[0]=getch();
			  strupr(selecdirec);
			  closegraph();
			   }

	if(selecdirec[0]=='Z'){
		initgraph(&gdriver, &gmode, ""); // inicializa modo grafico
		fondo(5,60);
		errorcode = graphresult();// lee el resultado de inicializacion
			// Ingresa si ocurri error
			    if (errorcode != grOk){
			       printf("ERROR en Graficos: %s\n", grapherrormsg(errorcode));
			       printf("Presione una tecla para salir...");
			       getch();// pausa
			       exit(1);// termina el programa con error

			       }
	       //	fondo(57,1);
		dibuja_directori_nodos(numx,numy,Cvertices,Gf);
	       //Datos del directorio de nodos
	       setcolor(63);
	       outtextxy(120,40,"DIRECTORIO DE NODOS GENERADO(SHKsoft)");
	       outtextxy(24,75,"(Vertices)");
	       outtextxy(150,75,"(Listas Asociadas)");

	       outtextxy(350,440,"<P>Valores Ponderados del Grafo");
	       outtextxy(350,455,"<Cualquier Tecla>Para Salir");
	       selecdirec2[0]=getch();
	       strupr(selecdirec2);
	       closegraph();
		    }

       if(selecdirec2[0]=='P') {
		int i,j;
		for(i=0;i<numx;i++) {
		     for(j=0;j<numy;j++){
		     if(Gf.A[i][j]==49)
			  cout<<"Los nodos "<<Gf.V[i]<<" --"<<Gf.V[j]<<" Con valor: "<<Gf.Mponderada[i][j]<<endl;

			  }
		     }
	 getch();
       }

}
/* La utilizacin del mouse se basa en condiciones que se comprueban
	en cada iteracin del ciclo infinito. Si nosotros deseamos definir
	un boton, deberemos decir:
	if((x>100)&&(x<200)&&(y>50)&&(y<80)&&(izq!=0)){
		accion
		accion
		accion
		//Esta lista de acciones se realizaran solo si se cumple la condicion
		//es decir si se presiona el boton.
	}
	donde el boton es un rectangulo con coordenadas(100,50,200,80).
	Si el mouse se encuentra dentro de este cuadrado y el boton a sido
	presionado(izq!=0) entonces se deber hacer un procedimiento.

	La programacin orientado a objetos facilita esto de sobremanera
	usted puede revisar el codigo de botones orientado a objetos
	para ver sus bondades.*/

//FUNCIONES DEL PROGRAMA
/********************************/
/* Muestra mouse en la pantalla */
void mostrar_mouse(){
	reg.x.ax = 0x1;
	int86(0x33, &reg, &reg);
}

/*******************************/
/* Oculta mouse en la pantalla */
void ocultar_mouse(){
	reg.x.ax = 0x2;
	int86(0x33, &reg, &reg);
}

/*******************************************************************/
/* Nos retorna el estado actual de la posicion y botones del mouse */
/* utilizando punteros                                             */
void estado_mouse(int *x,int *y, int *izq, int *der){
	res.r_ax = 3;
	intr(0x33,&res);
	*izq = res.r_bx & 0x01;
	*der = res.r_bx & 0x02;
	*der = *der >> 1;
	*x = res.r_cx ;
	*y = res.r_dx;
}

/***********************************************/
/* Inicializa el mouse en la posicion indicada */
/* utilizando punteros                         */
void inicia_mouse(int x,int y) {
	reg.x.ax=0;
	int86(0x33, &reg, &reg);
	reg.x.ax = 4;
	reg.x.cx = x;
	reg.x.dx = y;
	int86(0x33, &reg, &reg);
	mostrar_mouse();
}

/*inicilaiza el fondo del modo de video grafico*/
void fondo(int x,int y) {
   //Llenado interno del rectangulo que se crea
    setcolor(getmaxcolor());
    setfillstyle(SOLID_FILL,x);
    rectangle(15,10 ,615 , 467);
    floodfill(18, 51, getmaxcolor());
    //Regado o llenado de color afuera del rectangulo
    setfillstyle(SOLID_FILL,y);
    floodfill(1,1,getmaxcolor());


       }
/*Funcion que crea directorio de nodos*/
void dibuja_directori_nodos(int Nx ,int Ny ,int Nmayor,Grafo Gt){
int i,j;
int a=0,b=0,incC=0;
char cad[3]=" ";

	for(i=0;i<=Nx;i++) {
	    for(j=0;j<=Ny;j++) {
		 if(Gt.A[i][j]==49) {
		 //Lennado de color de los 2 rectangulos
		 setfillstyle(SOLID_FILL,56);
		 floodfill(102+a,92+b,56);
		 cad[0]=Gt.V[j];
		 //Rectangulo Interno
		 rectangle(100+a,90+b,140+a,110+b);
		 //Rectangulo Externo
		 rectangle(100+a,90+b,150+a,110+b);
		 //Linea que une los dos rectangulos
		 line(150+a,100+b,170+a,100+b);
		 //Salida del Texto dentro de los dos Rectangulos
		 outtextxy(122+a,98+b,cad);
		 a+=70;
		 }
		    }

	     a=0;
	     b+=40;
	     }
		fondo(57,1);
	  setcolor(4);
 for(i=0;i<Nmayor;i++){
   cad[0]=Gt.V[i];
   outtextxy(45,98+incC,cad);
   outtextxy(75,97+incC,"-->");
   rectangle(30,90+incC,75,110+incC);
   rectangle(30,90+incC,65,110+incC);
 //  setfillstyle(SOLID_FILL,0);
 //  floodfill(31,91+incC,0);

   incC+=40;
   }

}

/*Funcion que detrmina el tipo de grafo Dirigido o No*/
void funcion_determi_tipo_grafo(int fila,int colum ,Grafo Gt) {
int i=0,j;
int contaSuperior=0;
int maximo;
maximo=fila*colum;

  for(i=0;i< fila;i++)
   for(j=0;j<colum;j++){
	   if(Gt.A[i][j]==Gt.A[j][i]){
		   contaSuperior++;    }

			 }
  //Maximo-fila por que este solo es para matrices cuadradras
  //Conta superior tendra el valor de toda la matris - la longitud cuadrada de ella
   setcolor(59);
   if(contaSuperior==maximo)
      outtextxy(110,20,"El Grafo No es Dirigido Las Lineas son Aristas");
   else
      outtextxy(110,20,"El Grafo es Dirigido Las Linea Representa los Arcos");

}

/*Crea los destinos de los Grafos*/
void dibujar_Mdir(int Nmax,Grafo Gt){
 int i,j,fila=12,columna=14;
 char val[3]=" ";
 char val2[3]=" ";
 char *jer;
 //float num;
   setcolor(0);
      line(105,310,95,310);
      line(95,310,95,420);
      line(95,420,105,420);
      /*Llave de Sieere*/
      line(545,310,550,310);
      line(550,310,550,420);
      line(550,420,545,420);
      setcolor(1);
      outtextxy(140,300,"REPRESENTACION DE LA DIRECCION DEL GRAFO");
 /*Se presentan la lista de nodos con la direccion que tinen*/
 setcolor(63);
 for(i=0;i<=Nmax;i++) {
    for(j=0;j<=Nmax;j++) {
	if(Gt.A[i][j]==49) {
	 val[0]=Gt.V[i];
	 cout<<endl;
	 val2[0]=Gt.V[j];
   //	 num=Gt.Mponderada[i][j];
	 /*Mueve el cursor al inicio don de se desea escribir*/
	  moveto(100+fila,300+columna);
	 /* output text starting at the C.P. */
	 outtext(val);
	 outtext("-");
      /*	 if(Gt.Mponderada==0)
	 outtext("0");
	 else
	 outtext(arreglo);
	*/
	 outtext("->");
	 outtext(val2);
	 outtext(",");
	 fila+=48;
			   }
			 }
      fila=12;
      columna+=14;
		      }

}

void crear_rectangulos(int n1, int n2,Grafo *G) {
	int a=0,b=0,mov=0;//a se utiliza para deplazar los cuadros en las columnas
		      //b se utiliza para desplazar los rectangulos en las filas
	int i,j;
	char valor[3]=" ";
	 setcolor(1);
       /*Genera la etiquetas en la linea horiznotal de la matris*/
	 for(i=0;i<n2;i++){
	   valor[0]=G->V[i];
	   outtextxy(146+mov,70,valor);
	   mov+=40;
	   }
	   mov=0;
	for(j=0;j<n1;j++) {
	    valor[0]=G->V[j];
	    outtextxy(130,(86+mov+1),valor);
	    mov+=40;
	    }

	//Genera los rectangulos para trabajar con ellos en la matris;
	for(i=1;i<=n1;i++) {
	    for(j=1;j<=n2;j++) {
		 setcolor(1);
		 rectangle(140+a,80+b,160+a,100+b);
		 a+=40;
		    }

	     a=0;
	     b+=40;
	     }
   }

  /*inicializa con cero la matriz*/
void inigrafo(Grafo *G) {
	 int i,j;
	 G->N=0;
	 for(i=0;i<maxvert;i++) {
	       G->V[i]=' ';
	       for(j=0;j<maxvert;j++)
		  G->A[i][j]=0;
		  }
			}
 /*Crea un nuevo vertice*/
 void Nuevo_vertice(Grafo *G,char X,int n) {

	G->V[n]=X;

	}
/*Funcion que crea el boton salida*/
void boton_salida_siguiente(int Mox,int Moy,int Mizq,int &Mkey){
	if((Mox>35)&&(Mox<100)&&(Moy>440)&&(Moy<460)){
	      setcolor(63);
	      outtextxy(45,446,"SALIR");
	      if(Mizq!=0)
	      Mkey=tecla_Esc;
	      Bcolor=0;
	//Tiempo de retardo para que se pueda ver el cambio de color del mouse
	      delay(100);
						      }
	      if (Bcolor!=1) {
		 setcolor(1);
		 outtextxy(45,446,"SALIR");
		 Bcolor=0;
			     }
	//Boton Siguiente>
		if((Mox>530)&&(Mox<605)&&(Moy>415)&&(Moy<435))  {
		 setcolor(1);
		 outtextxy(540,420,"Siguie>");
		 delay(100);
		 }
      //Boton siguiente para cambiar de pantalla
	if(((Mox>530)&&(Mox<605))&&((Moy>415)&&(Moy<435))&&(Mizq!=0)) {
		Mkey=tecla_Esc;
		if(Vponderado=='S')
		pantalla=1;
		else
		pantalla=2;
							   }
}

/*Funcion crea circulos sin  las lineas*/
void dibujar_circulos(int frec, Grafo Gf){
     char val[3]=" ";
     int i;
	    for(i=0;i<frec;i++) {
		if(i==0) {
		circle(200,100,16);//Circulo1 A
		val[0]=Gf.V[i];
		outtextxy(198,98,val);
		}
		if(i==1) {
		 circle(400,100,16); //Circulo 2 B
		 val[0]=Gf.V[i];
		 outtextxy(398,98,val);
		 }
		if(i==4){
		 circle(200,250,16);//Circulo 5
		 val[0]=Gf.V[i];
		 outtextxy(198,248,val);
		 }

		if(i==5) {
		 circle(400,250,16);//Circulo 6
		 val[0]=Gf.V[i];
		 outtextxy(398,248,val);
		 }

		if(i==2 ) {
		 circle(250,175,16);//Circulo 3
		 val[0]=Gf.V[i];
		 outtextxy(248,173,val);
		 }

		if(i==6) {
		 circle(150,175,16); //Circulo 7
		 val[0]=Gf.V[i];
		 outtextxy(148,173,val);
		 }
		if(i==3) {
		 circle(350,175,16);//Circulo 4
		 val[0]=Gf.V[i];
		 outtextxy(348,173,val);
		 }
		if(i==7){
		 circle(450,175,16);//circulo 8
		 val[0]=Gf.V[i];
		 outtextxy(448,173,val);
		 }

		 }

}









/*Funcion que dibuja las lineas*/
void dibujar_lineas(Grafo Gt) {

/*Si pueden mejorar esto pues hacerlo pues ami por falta de timpo y de ganas no pude hacer nada mas SHKsoft*/


	       if(Gt.A[0][1]==49||Gt.A[1][0]==49){
		      //Linea para unir nodos "A-B" o "1-2" si MatrisA[0][1]=1 o MatrisA[1][0]=1
		      line(216,100,384,100);
		     }
	       if(Gt.A[0][0]==49||Gt.A[0][0]==49){
		     //Linea para unir los nodos A-A 0 1-1 si MatrisA[0][0]
		     line(212,90,212,70);
		     line(212,70,190,70);
		     line(190,70,190,87);
		     }


	       if(Gt.A[0][2]==49||Gt.A[2][0]==49) {
		   //Linea par unir los nodos A-C 1-3 si MatrisA[0][2]
		   line(208,115,236,164);
	       }
	       if(Gt.A[0][4]==49||Gt.A[4][0]==49) {
		  //Linea para unir los nodos A-E o 1-5 si Matris[0][4]
		  line(200,117,200,234);
		}
	       if(Gt.A[0][3]==49||Gt.A[3][0]==49) {
	      //Linea paar unir los nodos A-D o 1-4 si Matris[0][3]
	      line(214,108,337,165);
		}

	      if(Gt.A[0][5]==49||Gt.A[5][0]==49) {
		 //Linea para unir los puntos A-F 0 1-6 si matrisA[0][5]
		 line(212,111,386,240);            }
	      if(Gt.A[0][6]==49||Gt.A[6][0]==49) {
		   //Linea para unir los puntos A-G 0 1-7 si matrisA[0][6]
		   line(187,109,161,162);        }
	      if(Gt.A[0][7]==49||Gt.A[7][0]==49){
		   //Linea para unir los puntos A-H 0 1-8 si matrisA[0][7] o matrisA[7][0]
		   line(215,103,433,171);       }
		  /*Matris[1][2]   2*/
	      if(Gt.A[1][1]==49||Gt.A[1][1]==49){
	      //Line apara unir los nodos B-B 0 2-2 si matrisA[1][1] 0 matrisA[1][1]==1
		 line(388,87,388,68);
		 line(388,68,408,68);
		 line(408,68,408,85);
	      }
	      if(Gt.A[1][2]==49||Gt.A[2][1]==49) {
		   //Linea para unirlos puntoss B-C o 2-3 si matrisA[1][2]  o matrisA[2][1]
		   line(266,167,386,108);         }
	       if(Gt.A[1][3]==49||Gt.A[3][1]==49) {
		   //Linea para unir los puntos B-D 0 2-4 si matrisA[1][3] o matrisA[3][1]
		   line(391,113,359,162);          }
	       if(Gt.A[1][4]==49||Gt.A[4][1]==49) {
		   //Linea para unir los puntos B-E 0 2-5 si matrisA[1][4] o matrisA[4][1]
		   line(386,110,217,244);         }
	       if(Gt.A[1][5]==49||Gt.A[5][1]==49) {
		   //Linea para unir los puntos B-F 0 2-6 si matrisA[1][5] o matrisA[5][1]
		   line(399,116,399,234);          }
	       if(Gt.A[1][6]==49||Gt.A[6][1]==49) {
		   //Linea para unir los puntos B-G  0 2-7 si matrisA[1][6] o matrisA[6][1]
		   line(383,103,165,170);           }
	       if(Gt.A[1][7]==49||Gt.A[7][1]==49) {
		   //Linea para unir los puntos B-H 0 2-8 si matrisA[1][7] o matrisA[7][1]
		   line(410,112,441,160);         }

		/*MAtriz [2][3]*/

		//Union de de linea con nodos iguales
		//Linea para unir los puntos D-D o 3-3 si matrisA[2][2]  o matrisA[2][2]
		if(Gt.A[3][3]==49||Gt.A[3][3]==49) {
		    line(342,160,342,140);
		    line(342,140,356,140);
		    line(356,140,356,160);
		}
		//Linea para unir los puntos C-C o 2-2 si matrisA[2][2]  o matrisA[2][2]
		if(Gt.A[2][2]==49||Gt.A[2][2]==49) {
		    line(237,162,237,142);
		    line(237,142,260,142);
		    line(260,142,260,162);
		}
		//Linea para unir los puntos E-E o 4-4 si matrisA[4][4]  o matrisA[4][4]
		if(Gt.A[4][4]==49||Gt.A[4][4]==49) {
		    line(187,237,187,217);
		    line(187,217,206,217);
		    line(206,217,206,237);
		}
		//Linea para unir los puntos F-F o 5-5 si matrisA[5][5]  o matrisA[5][5]
		if(Gt.A[5][5]==49||Gt.A[5][5]==49) {
		    line(390,237,390,217);
		    line(390,217,408,217);
		    line(408,217,408,237);
		}
		//Linea para unir los puntos G-G o 6-6 si matrisA[6][6]  o matrisA[6][6]
		if(Gt.A[6][6]==49||Gt.A[6][6]==49) {
		    line(139,161,139,141);
		    line(139,141,161,141);
		    line(161,141,161,161);
		}
		//Linea para unir los puntos H-H o 7-7 si matrisA[7][7]  o matrisA[7][7]
		if(Gt.A[7][7]==49||Gt.A[7][7]==49) {
		    line(441,162,441,142);
		    line(441,142,462,142);
		    line(462,142,462,162);
		}

		if(Gt.A[2][3]==49||Gt.A[3][2]==49) {
		   //Linea para unir los puntos C-D o 3-4 si matrisA[2][3] o matrisA[3][2]
		   line(334,175,266,175);           }
		if(Gt.A[2][4]==49||Gt.A[4][2]==49) {
		   //Linea para unir los puntos C-E o 3-5 si matrisA[2][4] o matrisA[4][2]
		   line(238,185,207,236);          }
		if(Gt.A[2][5]==49||Gt.A[5][2]==49) {
		   //Linea para unir los puntos C-F o 3-6 si matrisA[2][5] o matrisA[5][2]
		   line(261,189,384,245);           }
		if(Gt.A[2][6]==49||Gt.A[6][2]==49) {
		  //Linea para unir los nodos C-G o 3-7 si matrisA[2][6] a matrisA[6][2]
		  line(233,174,165,174);           }
		if(Gt.A[2][7]==49||Gt.A[7][2]==49){
		  //Linea para unir los nodos C-H o 3-8 si matrisA[2][7] a matrisA[7][2]
		  line(266,172,387,136);
		  line(387,136,438,165);          }
		/*Matris[3][4]*/
		if(Gt.A[3][4]==49||Gt.A[4][3]==49) {
		  //Linea para unir los nodos D-E 0 4-5 si matrisA[3][4] o matrisA[4][3]
		  line(338,184,217,248);             }
		if(Gt.A[3][5]==49||Gt.A[5][3]==49) {
		  //Linea para unir los nodos D-F 0 4-6 si matrisA[3][5] o matrisA[5][3]
		  line(359,189,390,236);           }
		if(Gt.A[3][6]==49||Gt.A[6][3]==49) {
		  //Linea para unir los nodos D-G 0 4-7 si matrisA[3][6] o matrisA[6][3]
		  line(332,178,229,219);
		  line(229,219,161,186);            }
		if(Gt.A[3][7]==49||Gt.A[7][3]==49){
		  //Linea para unir los nodos D-H 0 4-7 si matrisA[3][7] o matrisA[7][3]
		  line(366,176,434,176);            }
		/*matris 4*/
		if(Gt.A[4][5]==49||Gt.A[5][4]==49){
		  //Linea para unir los nodos E-F 0 5-6 si matrisA[4][5] o matrisA[5][4]
		  line(215,253,383,253);          }
		if(Gt.A[4][6]==49||Gt.A[6][4]==49){
		   //Linea para unir los nodos E-G 0 5-7 si matrisA[4][6] o matrisA[6][4]
		   line(185,240,154,189);         }
		if(Gt.A[4][7]==49||Gt.A[7][4]==49){
		   //Linea para unir los nodos E-H 0 5-8 si matrisA[4][7] o matrisA[7][4]
		   line(216,250,435,182);         }
		 /*matriz 5*/
		if(Gt.A[5][6]==49||Gt.A[6][5]==49){
		   //Linea para unir los nodos F-G 0 6-7 si matrisA[5][6] o matrisA[6][5]
		   line(381,247,162,180);         }
		if(Gt.A[5][7]==49||Gt.A[7][5]==49){
		   //Linea para unbir los nodos F-H 0 6-8 si matrisA[5][7] o matrisA[7][5]
		   line(412,241,440,188);         }
		if(Gt.A[6][7]==49||Gt.A[7][6]==49){
		    //Linea para unir los nodos G-H 0 7-7 si matrisA[6][7] o matrisA[7][6]
		    line(150,190,150,274);
		    line(150,274,448,274);
		    line(448,274,448,191);          }


}


/*Funcion para presentar o llenar cada rectangulo y la matriz  */
void presentar_dato(int Mox,int Moy,int Mizq,int &Mkey,Grafo *G,int nx,int ny) {
     int Px=147,Py=87,centinela=0,BanderaMatriz=-1;
     int a=0,b=0,i,j;


     /*Pone los limites de los rectangulos dinamicamnete "Bueno ni tan Dinamica" con la ayuda de for*/
     for(i=1;i<=nx;i++) {
	    for(j=1;j<=ny;j++){
	       //Este ayuda a selecionar solo la fila 0 o 1 del arreglo de recuadros

	       //Selecciona la Primera fila con sus culumnas
		if((Mox>140+a)&&(Mox<160+a)&&(Moy>80+b)&&(Moy<100+b)&&(Mizq!=0)){
			  //cuadro 0,0
			  if((Mox>140&&Mox<160)&&(Moy>80&&Moy<100)) {
				   BanderaMatriz=0;
				   centinela=1;
				   Px=147;
				   Py=87+b;
				   goto salto_imprecion;
						  }
			   // cuadro 0,1
			   if((Mox>180&&Mox<200)&&(Moy>80&&Moy<100)) {
			       centinela=1;
			       BanderaMatriz=1;
			       Px=187;
			       Py=87+b;
				goto salto_imprecion;
				}
			   //cuadro 0,2
			  if((Mox>222&&Mox<238)&&(Moy>80&&Moy<100)) {
			    //  if(Moy>80&&Moy<100) {
			      centinela=1;
			      BanderaMatriz=2;
			      Px=227;
			      Py=87+b;
			    goto salto_imprecion;
			      }
			 //cuadro 0,3
			  if((Mox>260&&Mox<280)&&(Moy>80&&Moy<100))  {
			    centinela=1;
			    BanderaMatriz=3;
			    Px=267;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			  //cuadsro 0,4
			  if((Mox>300&&Mox<320)&&(Moy>80&&Moy<100))  {
			    centinela=1;
			    BanderaMatriz=4;
			    Px=307;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 0,5
			  if((Mox>340&&Mox<360)&&(Moy>80&&Moy<100))  {
			    centinela=1;
			    BanderaMatriz=5;
			    Px=347;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 0,6
			  if((Mox>380&&Mox<400)&&(Moy>80&&Moy<100))  {
			    centinela=1;
			    BanderaMatriz=6;
			    Px=387;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			  //cuadsro 0,7
			  if((Mox>420&&Mox<440)&&(Moy>80&&Moy<100))  {
			    centinela=1;
			    BanderaMatriz=7;
			    Px=427;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 0,8
			  if((Mox>460&&Mox<480)&&(Moy>80&&Moy<100))  {
			    centinela=1;
			    BanderaMatriz=8;
			    Px=467;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			     //cuadro 0,9
			  if((Mox>500&&Mox<520)&&(Moy>80&&Moy<100))  {
			    centinela=1;
			    BanderaMatriz=9;
			    Px=507;
			    Py=87+b;
			    goto salto_imprecion;
			    }

			      //cuadro 1,0
			  if((Mox>140&&Mox<160)&&(Moy>120&&Moy<140))  {
			    centinela=1;
			    BanderaMatriz=10;
			    Px=147;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 1,1
			  if((Mox>180&&Mox<200)&&(Moy>120&&Moy<140))  {
			    centinela=1;
			    BanderaMatriz=11;
			    Px=187;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 1,2
			 if((Mox>220&&Mox<240)&&(Moy>120&&Moy<140))  {
			    centinela=1;
			    BanderaMatriz=12;
			    Px=227;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 1,3
			 if((Mox>260&&Mox<280)&&(Moy>120&&Moy<140))  {
			    centinela=1;
			    BanderaMatriz=13;
			    Px=267;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 1,4
			  if((Mox>300&&Mox<320)&&(Moy>120&&Moy<140))  {
			    centinela=1;
			    BanderaMatriz=14;
			    Px=307;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 1,5
			  if((Mox>340&&Mox<360)&&(Moy>120&&Moy<140))  {
			    centinela=1;
			    BanderaMatriz=15;
			    Px=347;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 1,6
			 if((Mox>380&&Mox<400)&&(Moy>120&&Moy<140))  {
			    centinela=1;
			    BanderaMatriz=16;
			    Px=387;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 1,7
			 if((Mox>420&&Mox<440)&&(Moy>120&&Moy<140))  {
			    centinela=1;
			    BanderaMatriz=17;
			    Px=427;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 1,8
			 if((Mox>460&&Mox<480)&&(Moy>120&&Moy<140))  {
			    centinela=1;
			    BanderaMatriz=18;
			    Px=467;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 1,9
			 if((Mox>500&&Mox<520)&&(Moy>120&&Moy<140))  {
			    centinela=1;
			    BanderaMatriz=19;
			    Px=507;
			    Py=87+b;
			    goto salto_imprecion;
			    }

			 /*Fila 3*/
			   //cuadro 2,0
			  if((Mox>140&&Mox<160)&&(Moy>160&&Moy<180))  {
			    centinela=1;
			    BanderaMatriz=20;
			    Px=147;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 2,1
			  if((Mox>180&&Mox<200)&&(Moy>160&&Moy<180))  {
			    centinela=1;
			    BanderaMatriz=21;
			    Px=187;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 2,2
			 if((Mox>220&&Mox<240)&&(Moy>160&&Moy<180))  {
			    centinela=1;
			    BanderaMatriz=22;
			    Px=227;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 2,3
			 if((Mox>260&&Mox<280)&&(Moy>160&&Moy<180))  {
			    centinela=1;
			    BanderaMatriz=23;
			    Px=267;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 2,4
			  if((Mox>300&&Mox<320)&&(Moy>160&&Moy<180))  {
			    centinela=1;
			    BanderaMatriz=24;
			    Px=307;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 2,5
			  if((Mox>340&&Mox<360)&&(Moy>160&&Moy<180))  {
			    centinela=1;
			    BanderaMatriz=25;
			    Px=347;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 2,6
			 if((Mox>380&&Mox<400)&&(Moy>160&&Moy<180))  {
			    centinela=1;
			    BanderaMatriz=26;
			    Px=387;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 2,7
			 if((Mox>420&&Mox<440)&&(Moy>160&&Moy<180))  {
			    centinela=1;
			    BanderaMatriz=27;
			    Px=427;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 2,8
			 if((Mox>460&&Mox<480)&&(Moy>160&&Moy<180))  {
			    centinela=1;
			    BanderaMatriz=28;
			    Px=467;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 2,9
			 if((Mox>500&&Mox<520)&&(Moy>160&&Moy<180))  {
			    centinela=1;
			    BanderaMatriz=29;
			    Px=507;
			    Py=87+b;
			    goto salto_imprecion;
			    }

			 /*Fila 4*/
			   //cuadro 3,0
			  if((Mox>140&&Mox<160)&&(Moy>200&&Moy<220))  {
			    centinela=1;
			    BanderaMatriz=30;
			    Px=147;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 3,1
			  if((Mox>180&&Mox<200)&&(Moy>200&&Moy<220))  {
			    centinela=1;
			    BanderaMatriz=31;
			    Px=187;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 3,2
			 if((Mox>220&&Mox<240)&&(Moy>200&&Moy<220))  {
			    centinela=1;
			    BanderaMatriz=32;
			    Px=227;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 3,3
			 if((Mox>260&&Mox<280)&&(Moy>200&&Moy<220))  {
			    centinela=1;
			    BanderaMatriz=33;
			    Px=267;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 3,4
			  if((Mox>300&&Mox<320)&&(Moy>200&&Moy<220))  {
			    centinela=1;
			    BanderaMatriz=34;
			    Px=307;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 3,5
			  if((Mox>340&&Mox<360)&&(Moy>200&&Moy<220))  {
			    centinela=1;
			    BanderaMatriz=35;
			    Px=347;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 3,6
			 if((Mox>380&&Mox<400)&&(Moy>200&&Moy<220))  {
			    centinela=1;
			    BanderaMatriz=36;
			    Px=387;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 3,7
			 if((Mox>420&&Mox<440)&&(Moy>200&&Moy<220))  {
			    centinela=1;
			    BanderaMatriz=37;
			    Px=427;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 3,8
			 if((Mox>460&&Mox<480)&&(Moy>200&&Moy<220))  {
			    centinela=1;
			    BanderaMatriz=38;
			    Px=467;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 3,9
			 if((Mox>500&&Mox<520)&&(Moy>200&&Moy<220))  {
			    centinela=1;
			    BanderaMatriz=39;
			    Px=507;
			    Py=87+b;
			    goto salto_imprecion;
			    }

			 /*Fila 5*/
			   //cuadro 4,0
			  if((Mox>140&&Mox<160)&&(Moy>240&&Moy<260))  {
			    centinela=1;
			    BanderaMatriz=40;
			    Px=147;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 4,1
			  if((Mox>180&&Mox<200)&&(Moy>240&&Moy<260))  {
			    centinela=1;
			    BanderaMatriz=41;
			    Px=187;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 4,2
			 if((Mox>220&&Mox<240)&&(Moy>240&&Moy<260))  {
			    centinela=1;
			    BanderaMatriz=42;
			    Px=227;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 4,3
			 if((Mox>260&&Mox<280)&&(Moy>240&&Moy<260))  {
			    centinela=1;
			    BanderaMatriz=43;
			    Px=267;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 4,4
			  if((Mox>300&&Mox<320)&&(Moy>240&&Moy<260))  {
			    centinela=1;
			    BanderaMatriz=44;
			    Px=307;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 4,5
			  if((Mox>340&&Mox<360)&&(Moy>240&&Moy<260))  {
			    centinela=1;
			    BanderaMatriz=45;
			    Px=347;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 4,6
			 if((Mox>380&&Mox<400)&&(Moy>240&&Moy<260))  {
			    centinela=1;
			    BanderaMatriz=46;
			    Px=387;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 4,7
			 if((Mox>420&&Mox<440)&&(Moy>240&&Moy<260))  {
			    centinela=1;
			    BanderaMatriz=47;
			    Px=427;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 4,8
			 if((Mox>460&&Mox<480)&&(Moy>240&&Moy<260))  {
			    centinela=1;
			    BanderaMatriz=48;
			    Px=467;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 4,9
			 if((Mox>500&&Mox<520)&&(Moy>240&&Moy<260))  {
			    centinela=1;
			    BanderaMatriz=49;
			    Px=507;
			    Py=87+b;
			    goto salto_imprecion;
			    }

			 /*Fila 6*/
			   //cuadro 5,0
			  if((Mox>140&&Mox<160)&&(Moy>280&&Moy<300))  {
			    centinela=1;
			    BanderaMatriz=50;
			    Px=147;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 5,1
			  if((Mox>180&&Mox<200)&&(Moy>280&&Moy<300))  {
			    centinela=1;
			    BanderaMatriz=51;
			    Px=187;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 5,2
			 if((Mox>220&&Mox<240)&&(Moy>280&&Moy<300))  {
			    centinela=1;
			    BanderaMatriz=52;
			    Px=227;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 5,3
			 if((Mox>260&&Mox<280)&&(Moy>280&&Moy<300))  {
			    centinela=1;
			    BanderaMatriz=53;
			    Px=267;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 5,4
			  if((Mox>300&&Mox<320)&&(Moy>280&&Moy<300))  {
			    centinela=1;
			    BanderaMatriz=54;
			    Px=307;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 5,5
			  if((Mox>340&&Mox<360)&&(Moy>280&&Moy<300))  {
			    centinela=1;
			    BanderaMatriz=55;
			    Px=347;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 5,6
			 if((Mox>380&&Mox<400)&&(Moy>280&&Moy<300))  {
			    centinela=1;
			    BanderaMatriz=56;
			    Px=387;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 5,7
			 if((Mox>420&&Mox<440)&&(Moy>280&&Moy<300))  {
			    centinela=1;
			    BanderaMatriz=57;
			    Px=427;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 5,8
			 if((Mox>460&&Mox<480)&&(Moy>280&&Moy<300))  {
			    centinela=1;
			    BanderaMatriz=58;
			    Px=467;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 5,9
			 if((Mox>500&&Mox<520)&&(Moy>280&&Moy<300))  {
			    centinela=1;
			    BanderaMatriz=59;
			    Px=507;
			    Py=87+b;
			    goto salto_imprecion;
			    }


		     /*Fila 7*/
			   //cuadro 6,0
			  if((Mox>140&&Mox<160)&&(Moy>320&&Moy<340))  {
			    centinela=1;
			    BanderaMatriz=60;
			    Px=147;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 6,1
			  if((Mox>180&&Mox<200)&&(Moy>320&&Moy<340))  {
			    centinela=1;
			    BanderaMatriz=61;
			    Px=187;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 6,2
			 if((Mox>220&&Mox<240)&&(Moy>320&&Moy<340))  {
			    centinela=1;
			    BanderaMatriz=62;
			    Px=227;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 6,3
			 if((Mox>260&&Mox<280)&&(Moy>320&&Moy<340))  {
			    centinela=1;
			    BanderaMatriz=63;
			    Px=267;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 6,4
			  if((Mox>300&&Mox<320)&&(Moy>320&&Moy<340))  {
			    centinela=1;
			    BanderaMatriz=64;
			    Px=307;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 6,5
			  if((Mox>340&&Mox<360)&&(Moy>320&&Moy<340))  {
			    centinela=1;
			    BanderaMatriz=65;
			    Px=347;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 6,6
			 if((Mox>380&&Mox<400)&&(Moy>320&&Moy<340))  {
			    centinela=1;
			    BanderaMatriz=66;
			    Px=387;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 6,7
			 if((Mox>420&&Mox<440)&&(Moy>320&&Moy<340))  {
			    centinela=1;
			    BanderaMatriz=67;
			    Px=427;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 6,8
			 if((Mox>460&&Mox<480)&&(Moy>320&&Moy<340))  {
			    centinela=1;
			    BanderaMatriz=68;
			    Px=467;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 6,9
			 if((Mox>500&&Mox<520)&&(Moy>320&&Moy<340))  {
			    centinela=1;
			    BanderaMatriz=69;
			    Px=507;
			    Py=87+b;
			    goto salto_imprecion;
			    }

			 /*Fila 8*/
			   //cuadro 7,0
			  if((Mox>140&&Mox<160)&&(Moy>360&&Moy<380))  {
			    centinela=1;
			    BanderaMatriz=70;
			    Px=147;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 7,1
			  if((Mox>180&&Mox<200)&&(Moy>360&&Moy<380))  {
			    centinela=1;
			    BanderaMatriz=71;
			    Px=187;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 7,2
			 if((Mox>220&&Mox<240)&&(Moy>360&&Moy<380))  {
			    centinela=1;
			    BanderaMatriz=72;
			    Px=227;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 7,3
			 if((Mox>260&&Mox<280)&&(Moy>360&&Moy<380))  {
			    centinela=1;
			    BanderaMatriz=73;
			    Px=267;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 7,4
			  if((Mox>300&&Mox<320)&&(Moy>360&&Moy<380))  {
			    centinela=1;
			    BanderaMatriz=74;
			    Px=307;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 7,5
			  if((Mox>340&&Mox<360)&&(Moy>360&&Moy<380))  {
			    centinela=1;
			    BanderaMatriz=75;
			    Px=347;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 7,6
			 if((Mox>380&&Mox<400)&&(Moy>360&&Moy<380))  {
			    centinela=1;
			    BanderaMatriz=76;
			    Px=387;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 7,7
			 if((Mox>420&&Mox<440)&&(Moy>360&&Moy<380))  {
			    centinela=1;
			    BanderaMatriz=77;
			    Px=427;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 7,8
			 if((Mox>460&&Mox<480)&&(Moy>360&&Moy<380))  {
			    centinela=1;
			    BanderaMatriz=78;
			    Px=467;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 7,9
			 if((Mox>500&&Mox<520)&&(Moy>360&&Moy<380))  {
			    centinela=1;
			    BanderaMatriz=79;
			    Px=507;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 /*Fila 9*/
			   //cuadro 8,0
			  if((Mox>140&&Mox<160)&&(Moy>400&&Moy<420))  {
			    centinela=1;
			    BanderaMatriz=80;
			    Px=147;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 8,1
			  if((Mox>180&&Mox<200)&&(Moy>400&&Moy<420))  {
			    centinela=1;
			    BanderaMatriz=81;
			    Px=187;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 8,2
			 if((Mox>220&&Mox<240)&&(Moy>400&&Moy<420))  {
			    centinela=1;
			    BanderaMatriz=82;
			    Px=227;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 8,3
			 if((Mox>260&&Mox<280)&&(Moy>400&&Moy<420))  {
			    centinela=1;
			    BanderaMatriz=83;
			    Px=267;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 8,4
			  if((Mox>300&&Mox<320)&&(Moy>400&&Moy<420))  {
			    centinela=1;
			    BanderaMatriz=84;
			    Px=307;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 8,5
			  if((Mox>340&&Mox<360)&&(Moy>400&&Moy<420))  {
			    centinela=1;
			    BanderaMatriz=85;
			    Px=347;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 8,6
			 if((Mox>380&&Mox<400)&&(Moy>400&&Moy<420))  {
			    centinela=1;
			    BanderaMatriz=86;
			    Px=387;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 8,7
			 if((Mox>420&&Mox<440)&&(Moy>400&&Moy<420))  {
			    centinela=1;
			    BanderaMatriz=87;
			    Px=427;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 8,8
			 if((Mox>460&&Mox<480)&&(Moy>400&&Moy<420))  {
			    centinela=1;
			    BanderaMatriz=88;
			    Px=467;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 8,9
			 if((Mox>500&&Mox<520)&&(Moy>400&&Moy<420))  {
			    centinela=1;
			    BanderaMatriz=89;
			    Px=507;
			    Py=87+b;
			    goto salto_imprecion;
			    }

			 /*Fila 10*/
			   //cuadro 9,0
			  if((Mox>140&&Mox<160)&&(Moy>440&&Moy<460))  {
			    centinela=1;
			    BanderaMatriz=90;
			    Px=147;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 9,1
			  if((Mox>180&&Mox<200)&&(Moy>440&&Moy<460))  {
			    centinela=1;
			    BanderaMatriz=91;
			    Px=187;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 9,2
			 if((Mox>220&&Mox<240)&&(Moy>440&&Moy<460))  {
			    centinela=1;
			    BanderaMatriz=92;
			    Px=227;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 9,3
			 if((Mox>260&&Mox<280)&&(Moy>440&&Moy<460))  {
			    centinela=1;
			    BanderaMatriz=93;
			    Px=267;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //cuadro 9,4
			  if((Mox>300&&Mox<320)&&(Moy>440&&Moy<460))  {
			    centinela=1;
			    BanderaMatriz=94;
			    Px=307;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			   //cuador 9,5
			  if((Mox>340&&Mox<360)&&(Moy>440&&Moy<460))  {
			    centinela=1;
			    BanderaMatriz=95;
			    Px=347;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 9,6
			 if((Mox>380&&Mox<400)&&(Moy>440&&Moy<460))  {
			    centinela=1;
			    BanderaMatriz=96;
			    Px=387;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 9,7
			 if((Mox>420&&Mox<440)&&(Moy>440&&Moy<460))  {
			    centinela=1;
			    BanderaMatriz=97;
			    Px=427;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 9,8
			 if((Mox>460&&Mox<480)&&(Moy>440&&Moy<460))  {
			    centinela=1;
			    BanderaMatriz=98;
			    Px=467;
			    Py=87+b;
			    goto salto_imprecion;
			    }
			 //Cuadro 9,9
			 if((Mox>500&&Mox<520)&&(Moy>440&&Moy<460))  {
			    centinela=1;
			    BanderaMatriz=99;
			    Px=507;
			    Py=87+b;
			    goto salto_imprecion;
			    }



									}
		 a+=40;     }
		a=0;
		b+=40;
		}

 salto_imprecion:
		if(centinela==1) {
		   setcolor(1);
		   outtextxy(200,50,"Inserte el Dato");

		      while(_bios_keybrd(_KEYBRD_READY)==0);
			  Mkey=_bios_keybrd(_KEYBRD_READ);

			  letra[0]=(char)Mkey;
			if((letra[0]>=48)&&(letra[0]<=49)) {
			    cont=0;

			    //Fila Bloque de cuadros 1
			      if(BanderaMatriz==0)
				G->A[0][0]=(int)letra[0];
			     if(BanderaMatriz==1)
				G->A[0][1]=(int)letra[0];
			     if(BanderaMatriz==2)
				G->A[0][2]=(int)letra[0];
			     if(BanderaMatriz==3)
				G->A[0][3]=(int)letra[0];
			     if(BanderaMatriz==4)
				G->A[0][4]=(int)letra[0];
			     if(BanderaMatriz==5)
				G->A[0][5]=(int)letra[0];
			     if(BanderaMatriz==6)
				G->A[0][6]=(int)letra[0];
			     if(BanderaMatriz==7)
				G->A[0][7]=(int)letra[0];
			     if(BanderaMatriz==8)
				G->A[0][8]=(int)letra[0];
			     if(BanderaMatriz==9)
				G->A[0][9]=(int)letra[0];
			     if(BanderaMatriz==10)
				G->A[1][0]=(int)letra[0];
			     //Fila bloque de cuadros 2
			     if(BanderaMatriz==11)
				G->A[1][1]=(int)letra[0];
			     if(BanderaMatriz==12)
				G->A[1][2]=(int)letra[0];
			     if(BanderaMatriz==13)
				G->A[1][3]=(int)letra[0];
			     if(BanderaMatriz==14)
				G->A[1][4]=(int)letra[0];
			     if(BanderaMatriz==15)
				G->A[1][5]=(int)letra[0];
			     if(BanderaMatriz==16)
				G->A[1][6]=(int)letra[0];
			     if(BanderaMatriz==17)
				G->A[1][7]=(int)letra[0];
			     if(BanderaMatriz==18)
				G->A[1][8]=(int)letra[0];
			     if(BanderaMatriz==19)
				G->A[1][9]=(int)letra[0];
			     //Fila bloque de cuadros 3
			     if(BanderaMatriz==20)
				G->A[2][0]=(int)letra[0];
			     if(BanderaMatriz==21)
				G->A[2][1]=(int)letra[0];
			     if(BanderaMatriz==22)
				G->A[2][2]=(int)letra[0];
			     if(BanderaMatriz==23)
				G->A[2][3]=(int)letra[0];
			     if(BanderaMatriz==24)
				G->A[2][4]=(int)letra[0];
			      if(BanderaMatriz==25)
				G->A[2][5]=(int)letra[0];
			     if(BanderaMatriz==26)
				G->A[2][6]=(int)letra[0];
			     if(BanderaMatriz==27)
				G->A[2][7]=(int)letra[0];
			     if(BanderaMatriz==28)
				G->A[2][8]=(int)letra[0];
			     if(BanderaMatriz==29)
				G->A[2][9]=(int)letra[0];

			     //  Fila de cuadros 4
			     if(BanderaMatriz==30)
				G->A[3][0]=(int)letra[0];
			     if(BanderaMatriz==31)
				G->A[3][1]=(int)letra[0];
			     if(BanderaMatriz==32)
				G->A[3][2]=(int)letra[0];
			     if(BanderaMatriz==33)
				G->A[3][3]=(int)letra[0];
			     if(BanderaMatriz==34)
				G->A[3][4]=(int)letra[0];
			     if(BanderaMatriz==35)
				G->A[3][5]=(int)letra[0];
			     if(BanderaMatriz==36)
				G->A[3][6]=(int)letra[0];
			     if(BanderaMatriz==37)
				G->A[3][7]=(int)letra[0];
			     if(BanderaMatriz==38)
				G->A[3][8]=(int)letra[0];
			     if(BanderaMatriz==39)
				G->A[3][9]=(int)letra[0];

			     //  Fila de cuadros 4
			     if(BanderaMatriz==40)
				G->A[4][0]=(int)letra[0];
			     if(BanderaMatriz==41)
				G->A[4][1]=(int)letra[0];
			     if(BanderaMatriz==42)
				G->A[4][2]=(int)letra[0];
			     if(BanderaMatriz==43)
				G->A[4][3]=(int)letra[0];
			     if(BanderaMatriz==44)
				G->A[4][4]=(int)letra[0];
			     if(BanderaMatriz==45)
				G->A[4][5]=(int)letra[0];
			     if(BanderaMatriz==46)
				G->A[4][6]=(int)letra[0];
			     if(BanderaMatriz==47)
				G->A[4][7]=(int)letra[0];
			     if(BanderaMatriz==48)
				G->A[4][8]=(int)letra[0];
			     if(BanderaMatriz==49)
				G->A[4][9]=(int)letra[0];

			      //  Fila de cuadros 5
			     if(BanderaMatriz==50)
				G->A[5][0]=(int)letra[0];
			     if(BanderaMatriz==51)
				G->A[5][1]=(int)letra[0];
			     if(BanderaMatriz==52)
				G->A[5][2]=(int)letra[0];
			     if(BanderaMatriz==53)
				G->A[5][3]=(int)letra[0];
			     if(BanderaMatriz==54)
				G->A[5][4]=(int)letra[0];
			     if(BanderaMatriz==55)
				G->A[5][5]=(int)letra[0];
			     if(BanderaMatriz==56)
				G->A[5][6]=(int)letra[0];
			     if(BanderaMatriz==57)
				G->A[5][7]=(int)letra[0];
			     if(BanderaMatriz==58)
				G->A[5][8]=(int)letra[0];
			     if(BanderaMatriz==59)
				G->A[5][9]=(int)letra[0];

			     //  Fila de cuadros 6
			     if(BanderaMatriz==60)
				G->A[6][0]=(int)letra[0];
			     if(BanderaMatriz==61)
				G->A[6][1]=(int)letra[0];
			     if(BanderaMatriz==62)
				G->A[6][2]=(int)letra[0];
			     if(BanderaMatriz==63)
				G->A[6][3]=(int)letra[0];
			     if(BanderaMatriz==64)
				G->A[6][4]=(int)letra[0];
			     if(BanderaMatriz==65)
				G->A[6][5]=(int)letra[0];
			     if(BanderaMatriz==66)
				G->A[6][6]=(int)letra[0];
			     if(BanderaMatriz==67)
				G->A[6][7]=(int)letra[0];
			     if(BanderaMatriz==68)
				G->A[6][8]=(int)letra[0];
			     if(BanderaMatriz==69)
				G->A[6][9]=(int)letra[0];

			    //  Fila de cuadros 7
			     if(BanderaMatriz==70)
				G->A[7][0]=(int)letra[0];
			     if(BanderaMatriz==71)
				G->A[7][1]=(int)letra[0];
			     if(BanderaMatriz==72)
				G->A[7][2]=(int)letra[0];
			     if(BanderaMatriz==73)
				G->A[7][3]=(int)letra[0];
			     if(BanderaMatriz==74)
				G->A[7][4]=(int)letra[0];
			     if(BanderaMatriz==75)
				G->A[7][5]=(int)letra[0];
			     if(BanderaMatriz==76)
				G->A[7][6]=(int)letra[0];
			     if(BanderaMatriz==77)
				G->A[7][7]=(int)letra[0];
			     if(BanderaMatriz==78)
				G->A[7][8]=(int)letra[0];
			     if(BanderaMatriz==79)
				G->A[7][9]=(int)letra[0];

			    //  Fila de cuadros 8
			     if(BanderaMatriz==80)
				G->A[8][0]=(int)letra[0];
			     if(BanderaMatriz==81)
				G->A[8][1]=(int)letra[0];
			     if(BanderaMatriz==82)
				G->A[8][2]=(int)letra[0];
			     if(BanderaMatriz==83)
				G->A[8][3]=(int)letra[0];
			     if(BanderaMatriz==84)
				G->A[8][4]=(int)letra[0];
			     if(BanderaMatriz==85)
				G->A[8][5]=(int)letra[0];
			     if(BanderaMatriz==86)
				G->A[8][6]=(int)letra[0];
			     if(BanderaMatriz==87)
				G->A[8][7]=(int)letra[0];
			     if(BanderaMatriz==88)
				G->A[8][8]=(int)letra[0];
			     if(BanderaMatriz==89)
				G->A[8][9]=(int)letra[0];

			    //  Fila de cuadros 9
			     if(BanderaMatriz==90)
				G->A[9][0]=(int)letra[0];
			     if(BanderaMatriz==91)
				G->A[9][1]=(int)letra[0];
			     if(BanderaMatriz==92)
				G->A[9][2]=(int)letra[0];
			     if(BanderaMatriz==93)
				G->A[9][3]=(int)letra[0];
			     if(BanderaMatriz==94)
				G->A[9][4]=(int)letra[0];
			     if(BanderaMatriz==95)
				G->A[9][5]=(int)letra[0];
			     if(BanderaMatriz==96)
				G->A[9][6]=(int)letra[0];
			     if(BanderaMatriz==97)
				G->A[9][7]=(int)letra[0];
			     if(BanderaMatriz==98)
				G->A[9][8]=(int)letra[0];
			     if(BanderaMatriz==99)
				G->A[9][9]=(int)letra[0];

		       /*Impresion del dato dentro del recuadro*/
			  setcolor(7);
			  outtextxy(Px,Py,"1");
			  outtextxy(Px,Py,"0");
			  setcolor(4);
			  outtextxy(Px,Py,letra);
			  setcolor(7);
			  outtextxy(200,50,"Inserte el Dato");
			  /*Lo ocupe para ver los valores que tenia la matris de adyanecia
			char vec[3]=" ";
			for(int i=0;i<nx;i++)
			 for(int j=0;j<ny;j++){
				vec[0]=G->A[i][j];
				setcolor(1);
				outtextxy(400,200,vec);
				getch();
				setcolor(7);
				outtextxy(400,200,vec);
						   }
						*/

							    }
				   }




   }